@component('panel.layouts.component', ['title' => 'ثبت محصول جدید'])

    @slot('style')
        <style>
            .card-header {
                text-align: center !important;
            }

            .form-control {

                background-color: hsl(315, 22%, 86%);
            }

            .required {
                color: red;
            }

            .py-5 {
                padding-top: 0 !important;
            }

            .select2 {
                width: 100% !important;
            }

            .photo {
                border: 0px;
                background-color: #fff;
            }

            /* ---------------------------------------
  /* Fine Uploader Gallery View Styles
  /* ---------------------------------------*/

.note {
  width: 500px;
  margin: 50px auto;
  font-size: 1.1em;
  color: #333;
  text-align: justify;
}
#drop-area {
  border: 2px dashed #ccc;
  border-radius: 20px;
  width: 480px;
  margin: 50px auto;
  padding: 20px;
}
#drop-area.highlight {
  border-color: purple;
}
p {
  margin-top: 0;
}
.my-form {
  margin-bottom: 10px;
}
#gallery {
  margin-top: 10px;
}
#gallery img {
  width: 150px;
  margin-bottom: 10px;
  margin-right: 10px;
  vertical-align: middle;
}
.button {
  display: inline-block;
  padding: 10px;
  background: #ccc;
  cursor: pointer;
  border-radius: 5px;
  border: 1px solid #ccc;
}
.button:hover {
  background: #ddd;
}
#fileElem {
  display: none;
}
        </style>
    @endslot
    @slot('subject')
        <h1><i class="fa fa-users"></i> ثبت محصول جدید </h1>
        <p>ثبت محصول جدید در فروشگاه.</p>
    @endslot
    @slot('breadcrumb')
        <li class="breadcrumb-item">محصولات</li>
    @endslot

    @slot('content')
        <div class="auth-background h-auto py-5">
            <div class="container py-5">
                <div class="row align-items-center ">
                    <div class="col-lg-12 col-md-12 mx-auto">
                        <div class="card">
                            <div class="card-header"><strong>{{ __('ثبت محصول جدید') }}</strong></div>
                            @component('product::components.message')
                            @endcomponent
                            <div class="card-body mx-lg-5 px-lg-3">
                                <form method="POST" action="{{ route('products.store') }}"
                                      enctype="multipart/form-data">
                                    @csrf

                                    <div class="form-group">
                                        <label for="title">{{ __('product.title') }}</label><i class="required">&nbsp;
                                            *</i>
                                        <input id="title" type="text"
                                               class="form-control @error('title') is-invalid @enderror" name="title"
                                               value="{{ old('title') }}" autocomplete="title" autofocus>

                                        @error('title')
                                        <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                        @enderror
                                    </div>
                                    <div class="form-row ">
                                        <div class="form-group col-lg-4">
                                            <label for="slug">{{ __('product.slug') }}</label>
                                            <input type="text" name="slug"
                                                   class="form-control @error('slug') is-invalid  @enderror"
                                                   value="{{old('slug')}}" autocomplete="slug" autofocus>
                                            @error('slug')
                                            <div class="alert alert-danger">{{$message}}</div>
                                            @enderror
                                        </div>
                                        <div class="form-group col-lg-4">
                                            <label for="sku">{{ __('product.sku') }}</label>
                                            <input id="sku" type="text"
                                                   class="form-control @error('sku') is-invalid @enderror" name="sku"
                                                   autocomplete="sku" value="{{ old('sku') }}" autofocus>

                                            @error('sku')
                                            <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                            @enderror
                                        </div>
                                        <div class="form-group col-lg-4">
                                            <label for="type">{{ __('product.type') }}</label></label><i
                                                class="required">&nbsp;
                                                *</i>
                                            <select id="type" type="text"
                                                    class="form-control @error('type') is-invalid @enderror" name="type"
                                                    value="{{ old('type') }}" autocomplete="type">
                                                <option value="">انتخاب کنید</option>
                                                <option value="0" {{ (old('type') == '0') ? 'selected' : '' }}>ساده
                                                </option>
                                                <option value="1" {{ (old('type') == '1') ? 'selected' : '' }}>متغیر
                                                </option>
                                                <option value="2" {{ (old('type') == '2') ? 'selected' : '' }}>باندل
                                                </option>

                                            </select>

                                            @error('type')
                                            <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                            @enderror
                                        </div>
                                    </div>
                                    <div class="form-row ">
                                        <div class="form-group col-lg-4">
                                            <label for="title">{{ __('product.price') }}</label><i class="required">&nbsp;
                                                *</i>
                                            <input id="input.price" type="text"
                                                   class="form-control price @error('price') is-invalid @enderror"
                                                   name="price"
                                                   value="{{ old('price') }}" autocomplete="price" autofocus>

                                            @error('price')
                                            <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                            @enderror
                                        </div>
                                        <div class="form-group col-lg-4">
                                            <label for="sale_price">@lang('product.sale_price')</label>
                                            <input id="sale_price" type="text"
                                                   class="form-control price @error('sale_price') is-invalid @enderror"
                                                   name="sale_price"
                                                   value="{{ old('sale_price') }}" autocomplete="sale_price" autofocus>

                                            @error('sale_price')
                                            <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                            @enderror
                                        </div>
                                        <div class="form-group col-lg-4">
                                            <label for="status">{{ __('product.status') }}</label><i class="required">&nbsp;
                                                *</i>
                                            <select id="status" type="text"
                                                    class="form-control  @error('status') is-invalid @enderror"
                                                    name="status"
                                                    autocomplete="status">
                                                <option value="">انتخاب کنید</option>
                                                <option value="1" {{ (old('status') == '1') ? 'selected' : '' }}>موجود
                                                </option>
                                                <option value="0" {{ (old('status') == '0') ? 'selected' : '' }}>
                                                    ناموجود
                                                </option>
                                            </select>
                                            @error('status')
                                            <span class="invalid-feedback" role="alert">
                                               <strong>{{ $message }}</strong>
                                            </span>
                                            @enderror
                                        </div>
                                    </div>
                                    <div class="form-group">
                                        <label for="discription">{{ __('product.discription') }}</label></label><i
                                            class="required">&nbsp; *</i>
                                        <textarea id="discription" type="text"
                                                  class="form-control  @error('discription') is-invalid @enderror"
                                                  name="discription"

                                                  autocomplete="discription"
                                                  autofocus>{{ old('discription') }}</textarea>

                                        @error('discription')
                                        <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                        @enderror
                                    </div>
                                    <div class="form-group">
                                        <label for="categories">{{ __('product.categories') }}</label><i
                                            class="required">&nbsp; *</i>
                                        <select id=""
                                                class="form-control select2 @error('categories') is-invalid @enderror"
                                                name="categories[]" multiple>

                                            <option value="">انتخاب کنید</option>
                                            @foreach($categories as $cat)
                                                <option value="{{$cat->id }}">{{$cat->title}}</option>
                                            @endforeach
                                        </select>
                                        @error('categories')
                                        <span class="invalid-feedback" role="alert">
                                            <strong>{{ $message }}</strong>
                                        </span>
                                        @enderror

                                    </div>
                                    <div class="row col-md-4">
                                        <div class="form-group ">


                                            <label for="title">{{ __('product.featured_image') }}</label><i
                                                class="required">&nbsp; *</i>
                                            <input type="file" name="featured_image"

                                                   class="form-control photo  browse @error('featured_image') is-invalid  @enderror"
                                                   value="{{old('featured_image')}}" autocomplete="featured_image"
                                                   autofocus accept="image/*">


                                            @error('featured_image')
                                            <span class="invalid-feedback" role="alert">
                                                 <strong>{{ $message }}</strong>
                                            </span>
                                            @enderror
                                            <div class="ml-2 col-sm-6 ">

                                                <img src="" id="preview" class="img-thumbnail">
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <span class="btn btn-sm btn-success file_creator"><i
                                                class="fa fa-plus"></i></span>
                                        <div class="col-md-4 last_image">
                                            <div class="form-group ">
                                                <label for="title">{{ __('product.gallery_image') }}</label><i
                                                    class="required">&nbsp; *</i>
                                                <input type="file" name="gallery_image[]" id="gallery_image"

                                                       class="form-control photo @error('gallery_image') is-invalid  @enderror"
                                                       value="{{old('gallery_image')}}" autocomplete="gallery_image"
                                                       autofocus multiple>

                                                @error('gallery_image')
                                                <span class="invalid-feedback" role="alert">
                                                    <strong>{{ $message }}</strong>
                                                </span>
                                                @enderror
                                                <div class="ml-2 col-sm-6 ">

                                                    <img src="" id="previewGallery" class="img-thumbnail">
                                                </div>
                                            </div>
                                        </div>
                                    </div>


                                    <div id="drop-area">

                                       <input type="file" id="fileElem" multiple accept="image/*"
                                                   onchange="handleFiles(this.files)">
                                        <label class="button" for="fileElem"> ساخت گالری محصولات</label>

                                        <progress id="progress-bar" max=100 value=0></progress>
                                        <div id="gallery">
                                        </div>
                                    </div>





                                    <div class="form-group mb-0">
                                        <div class="">
                                            <button type="submit" class="btn btn-primary">
                                                {{ __('ثبت محصول') }}
                                            </button>

                                            <a href={{ route('products.index') }} type="button" class="btn btn-warning">
                                                انصراف</a>
                                        </div>
                                    </div>
                                </form>
                            </div>
                            <div class="card-footer">

                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    @endslot

    @slot('script')
        <script>

            $(document).on('click', '.file_creator', function () {
                $(".last_image:last").after($(".last_image:last").clone());

            });

            $(document).on("click", ".browse", function () {
                var file = $(this).parents().find(".file");
                file.trigger("click");
            });
            // show images feature
            $('input[name="featured_image"]').change(function (e) {
                var fileName = e.target.files[0].name;
                $("#file").val(fileName);

                var reader = new FileReader();
                reader.onload = function (e) {
                    // get loaded data and render thumbnail.
                    document.getElementById("preview").src = e.target.result;

                };
                // read the image file as a data URL.
                reader.readAsDataURL(this.files[0]);
            });
            //**************************show images gallery**********************************************
            $(document).on("click", ".browse", function () {
                var file = $(this).parents().find(".file");
                file.trigger("click");
            });
            $('input[name="gallery_image[]"]').change(function (e) {
                var fileName = e.target.files[0].name;
                $("#file").val(fileName);

                var reader = new FileReader();
                reader.onload = function (e) {
                    // get loaded data and render thumbnail.
                    document.getElementById("previewGallery").src = e.target.result;

                };
                // read the image file as a data URL.
                reader.readAsDataURL(this.files[0]);
            });
        //    ****************************************
            // ************************ Drag and drop ***************** //
            let dropArea = document.getElementById("drop-area")

// Prevent default drag behaviors
            ;['dragenter', 'dragover', 'dragleave', 'drop'].forEach(eventName => {
                dropArea.addEventListener(eventName, preventDefaults, false)
                document.body.addEventListener(eventName, preventDefaults, false)
            })

// Highlight drop area when item is dragged over it
            ;['dragenter', 'dragover'].forEach(eventName => {
                dropArea.addEventListener(eventName, highlight, false)
            })

            ;['dragleave', 'drop'].forEach(eventName => {
                dropArea.addEventListener(eventName, unhighlight, false)
            })

            // Handle dropped files
            dropArea.addEventListener('drop', handleDrop, false)

            function preventDefaults (e) {
                e.preventDefault()
                e.stopPropagation()
            }

            function highlight(e) {
                dropArea.classList.add('highlight')
            }

            function unhighlight(e) {
                dropArea.classList.remove('active')
            }

            function handleDrop(e) {
                var dt = e.dataTransfer
                var files = dt.files

                handleFiles(files)
            }

            let uploadProgress = []
            let progressBar = document.getElementById('progress-bar')

            function initializeProgress(numFiles) {
                progressBar.value = 0
                uploadProgress = []

                for(let i = numFiles; i > 0; i--) {
                    uploadProgress.push(0)
                }
            }

            function updateProgress(fileNumber, percent) {
                uploadProgress[fileNumber] = percent
                let total = uploadProgress.reduce((tot, curr) => tot + curr, 0) / uploadProgress.length
                console.debug('update', fileNumber, percent, total)
                progressBar.value = total
            }

            function handleFiles(files) {
                files = [...files]
                initializeProgress(files.length)
                files.forEach(uploadFile)
                files.forEach(previewFile)
            }

            function previewFile(file) {
                let reader = new FileReader()
                reader.readAsDataURL(file)
                reader.onloadend = function() {
                    let img = document.createElement('img')
                    img.src = reader.result
                    document.getElementById('gallery').appendChild(img)
                }
            }

            function uploadFile(file, i) {
                var url = 'https://api.cloudinary.com/v1_1/joezimim007/image/upload'
                var xhr = new XMLHttpRequest()
                var formData = new FormData()
                xhr.open('POST', url, true)
                xhr.setRequestHeader('X-Requested-With', 'XMLHttpRequest')

                // Update progress (can be used to show progress indicator)
                xhr.upload.addEventListener("progress", function(e) {
                    updateProgress(i, (e.loaded * 100.0 / e.total) || 100)
                })

                xhr.addEventListener('readystatechange', function(e) {
                    if (xhr.readyState == 4 && xhr.status == 200) {
                        updateProgress(i, 100) // <- Add this
                    }
                    else if (xhr.readyState == 4 && xhr.status != 200) {
                        // Error. Inform the user
                    }
                })

                formData.append('upload_preset', 'ujpu6gyk')
                formData.append('file', file)
                xhr.send(formData)
            }

        </script>
    @endslot

@endcomponent

